/*
   Sistemas Integrados TEKNISA
   Nome: 0002_FASSTPO_FATURA_SERVICO.SQL
   Descrio: Procedimento para Faturamento de Servios.
   Criao: 30/10/2007 Vanrochris Helbert Vieira
*/

CREATE OR REPLACE
PROCEDURE FATURA_SERVICO
   (P_CDCLIENTE  IN VARCHAR2,
    P_CDOPERAPUR IN APURFATUFAS.CDOPERAPUR%TYPE,
    P_NAC        IN VARCHAR2,
    P_MES       IN DATE)
AS
   V_CDEMPRESA       VARCHAR2(2);
   V_CDPRODUTO       VARCHAR2(10);
   V_PRXAPURACAO     VARCHAR2(20);
   V_CDFILIAL        VARCHAR2(4);
   V_IDGERANFUNIFICA VARCHAR2(1);
   V_GRUPONF         VARCHAR2(2);
   V_VRFATU          NUMBER;
   V_MAXDTAPURADA    DATE;
   V_MINDTAPURADA    DATE;
   V_DATA            DATE;
   V_DSBOLETCLIE     PARCLIEFAS.DSBOLETCLIE%TYPE;
   V_DSFATURCLIE     PARCLIEFAS.DSFATURCLIE%TYPE;
   V_IDAPURACAO      VARCHAR2(1);
BEGIN
   SELECT TRUNC(SYSDATE)
     INTO V_DATA
     FROM DUAL;
   FOR CUR_CHT IN (SELECT C.CDCLIENTE, H.CDTIPOSERV, H.NRSEQUCHT, H.NRPROPOSFAS,
                          H.NRVERPROPFAS, H.NRSERVCONT, T.NMTIPOSERV, F.NMFUNC,H.IDSTATUSCHT, 
                          ' - Hr. '||REPLACE(TRIM(TO_CHAR(TRUNC(H.QTHRAPROFATUCHT), '9,999,990')), ',', '.')||':'||
                          TRIM(' ' FROM TO_CHAR(TRUNC((H.QTHRAPROFATUCHT - TRUNC(H.QTHRAPROFATUCHT)) * 60), '00')) AS QTHRAPROFATUCHT,
                          DECODE(H.QTHREXTRSERVCHT, 0, '', ' - Hr. Extra '||REPLACE(TRIM(TO_CHAR(TRUNC(H.QTHREXTRSERVCHT), '9,999,990')), ',', '.')||':'||
                          TRIM(' ' FROM TO_CHAR(TRUNC((H.QTHREXTRSERVCHT - TRUNC(H.QTHREXTRSERVCHT)) * 60), '00'))) AS QTHREXTRSERVCHT, H.CDEMPRESA, H.CDFUNC
                     FROM CHT H, CONTRATOSERV C, TIPOSERV T, ENDECLIE E,
                          FUNCIONARIO F
                    WHERE ((INSTR(P_CDCLIENTE, '_' || C.CDCLIENTE || '_') > 0) OR (P_CDCLIENTE = 'C'))
                      AND H.IDSTATUSCHT in ('A', 'N')
                      AND E.IDTPENDECLIE = 'P'
                      AND ((E.CDPAIS <> '0055' AND (INSTR(P_NAC, '_I_') > 0)) OR (E.CDPAIS = '0055' AND (INSTR(P_NAC, '_N_') > 0)))
                      AND E.CDCLIENTE = C.CDCLIENTE
                      AND C.CDTIPOSERV = T.CDTIPOSERV
                      AND C.NRPROPOSFAS = H.NRPROPOSFAS
                      AND C.NRVERPROPFAS = H.NRVERPROPFAS
                      AND C.NRSERVCONT = H.NRSERVCONT
                      AND C.CDTIPOSERV = H.CDTIPOSERV
                      AND H.CDEMPRESA = F.CDEMPRESA
                      AND H.CDFUNC = F.CDFUNC
                      AND C.IDTIPOCOBRCONT = 'H'
                    ORDER BY C.CDCLIENTE, H.CDTIPOSERV, H.NRSEQUCHT, H.NRPROPOSFAS,
                          H.NRVERPROPFAS, H.NRSERVCONT, T.NMTIPOSERV, F.NMFUNC, H.IDSTATUSCHT) LOOP
      BEGIN
         SELECT MAX(CDPRODFATU)
           INTO V_CDPRODUTO
           FROM TIPOSERV
          WHERE CDTIPOSERV = CUR_CHT.CDTIPOSERV;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            NULL;
      END;

      BEGIN
         SELECT P.DSBOLETCLIE, P.DSFATURCLIE, P.CDEMPRESA, F.CDFILIAL,
                P.IDGERANFUNIFICA
           INTO V_DSBOLETCLIE, V_DSFATURCLIE, V_CDEMPRESA, V_CDFILIAL,
                V_IDGERANFUNIFICA
           FROM PARCLIEFAS P, FILIAL F
          WHERE P.IDTPFATUCLIE = '5'
            AND P.CDCLIENTE = CUR_CHT.CDCLIENTE
            AND P.CDEMPRESA = F.CDEMPRESA
            AND ROWNUM = 1;
      EXCEPTION
           WHEN NO_DATA_FOUND THEN
           NULL;
      END;

      BEGIN
         SELECT MAX(DTSERVPREST)
           INTO V_MAXDTAPURADA
           FROM SERVPREST
          WHERE NRAPURFATFAS IS NULL
            AND CDCLIENTE = CUR_CHT.CDCLIENTE
            AND NRPROPOSFAS = CUR_CHT.NRPROPOSFAS
            AND NRVERPROPFAS = CUR_CHT.NRVERPROPFAS
            AND NRSERVCONT = CUR_CHT.NRSERVCONT
            AND NRSEQUCHT = CUR_CHT.NRSEQUCHT
            AND CDTIPOSERV = CUR_CHT.CDTIPOSERV
          GROUP BY CDCLIENTE, CDTIPOSERV, NRSEQUCHT, NRPROPOSFAS,
                NRVERPROPFAS, NRSERVCONT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
           NULL;
      END;

      BEGIN
         SELECT MIN(DTSERVPREST)
           INTO V_MINDTAPURADA
           FROM SERVPREST
          WHERE NRAPURFATFAS IS NULL
            AND CDCLIENTE = CUR_CHT.CDCLIENTE
            AND NRPROPOSFAS = CUR_CHT.NRPROPOSFAS
            AND NRVERPROPFAS = CUR_CHT.NRVERPROPFAS
            AND NRSERVCONT = CUR_CHT.NRSERVCONT
            AND NRSEQUCHT = CUR_CHT.NRSEQUCHT
            AND CDTIPOSERV = CUR_CHT.CDTIPOSERV
          GROUP BY CDCLIENTE, CDTIPOSERV, NRSEQUCHT, NRPROPOSFAS,
                NRVERPROPFAS, NRSERVCONT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
           NULL;
      END;

      V_VRFATU := CALCULA_FAT_MDO(CUR_CHT.NRPROPOSFAS, CUR_CHT.NRVERPROPFAS, CUR_CHT.CDTIPOSERV,
                                  CUR_CHT.NRSERVCONT, CUR_CHT.NRSEQUCHT);

      IF V_VRFATU > 0 THEN
         V_DSBOLETCLIE := SUBSTR('Proposta: '||CUR_CHT.NRPROPOSFAS||' - '||CUR_CHT.NMFUNC||
                          CUR_CHT.QTHRAPROFATUCHT||CUR_CHT.QTHREXTRSERVCHT||' - '||TO_CHAR(V_MINDTAPURADA, 'DD/MM/YYYY')||' a '||
                          TO_CHAR(V_MAXDTAPURADA, 'DD/MM/YYYY'), 1, 2000)||'.';

         IF V_IDGERANFUNIFICA = 'S' THEN
            V_GRUPONF := '01';
         ELSE
            V_GRUPONF := '';
            BEGIN
               SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(CDGRUPONFAPUR + 1))), 2, '0')
                 INTO V_GRUPONF
                 FROM APURFATUFAS
                WHERE CDCLIENTE = CUR_CHT.CDCLIENTE
                  AND IDAPURFATFAS = '1'
                  AND IDSTAPFATFAS = 'P'
                GROUP BY CDCLIENTE;
            EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   NULL;
            END;
            IF V_GRUPONF IS NULL THEN
               V_GRUPONF := '01';
            END IF;
         END IF;

         NOVO_CODIGO('APURFATUFAS', V_PRXAPURACAO);
         
         IF CUR_CHT.IDSTATUSCHT = 'N' THEN 
            V_IDAPURACAO := 'N';
          ELSE
            V_IDAPURACAO := 'P';
          END IF;
          
            
         INSERT INTO APURFATUFAS 
            (CDFILIAL, CDCLIENTE, NRAPURFATFAS, DTAPURFATFAS,
             VRTOTAFATFAS, DSEMISSPRONF, CDOPERAPUR, CDEMPRESA,
             CDTIPOSERV, CDPRODUTO, IDAPURFATFAS, IDSTAPFATFAS,
             IDCOMIFATFAS, DSBOLEFATFAS, DTMESAPURFAS, CDGRUPONFAPUR, 
             CDEMPRESAFUNC, CDFUNC, NRPROPOSFAS, NRVERPROPFAS)
         VALUES 
            (V_CDFILIAL, CUR_CHT.CDCLIENTE, SUBSTR(V_PRXAPURACAO, 11, 10), V_DATA,
             V_VRFATU, V_DSFATURCLIE, P_CDOPERAPUR, V_CDEMPRESA,
             CUR_CHT.CDTIPOSERV, V_CDPRODUTO, '1', V_IDAPURACAO,
             'N', V_DSBOLETCLIE, P_MES, V_GRUPONF, 
             CUR_CHT.CDEMPRESA, CUR_CHT.CDFUNC, CUR_CHT.NRPROPOSFAS, CUR_CHT.NRVERPROPFAS);
         UPDATE SERVPREST
            SET NRAPURFATFAS = SUBSTR(V_PRXAPURACAO, 11, 10)
          WHERE NRAPURFATFAS IS NULL
            AND CDTIPOSERV = CUR_CHT.CDTIPOSERV
            AND NRSEQUCHT = CUR_CHT.NRSEQUCHT
            AND CDCLIENTE = CUR_CHT.CDCLIENTE
            AND NRPROPOSFAS = CUR_CHT.NRPROPOSFAS
            AND NRVERPROPFAS = CUR_CHT.NRVERPROPFAS
            AND NRSERVCONT = CUR_CHT.NRSERVCONT;
         UPDATE CHT
            SET IDSTATUSCHT = 'R'
          WHERE IDSTATUSCHT = 'A'
            AND CDTIPOSERV = CUR_CHT.CDTIPOSERV
            AND NRSEQUCHT = CUR_CHT.NRSEQUCHT
            AND NRPROPOSFAS = CUR_CHT.NRPROPOSFAS
            AND NRVERPROPFAS = CUR_CHT.NRVERPROPFAS
            AND NRSERVCONT = CUR_CHT.NRSERVCONT;
      ELSE
         UPDATE CHT
            SET IDSTATUSCHT = 'N', DSALTERACAOCHT = 'CHT no gerou apurao, pois o clculo do valor a ser pago foi igual a R$ 0,00.'
          WHERE IDSTATUSCHT = 'A'
            AND CDTIPOSERV = CUR_CHT.CDTIPOSERV
            AND NRSEQUCHT = CUR_CHT.NRSEQUCHT
            AND NRPROPOSFAS = CUR_CHT.NRPROPOSFAS
            AND NRVERPROPFAS = CUR_CHT.NRVERPROPFAS
            AND NRSERVCONT = CUR_CHT.NRSERVCONT;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('FATURA_SERVICO','5.05.012'); END;
/
